<?php if ( ! defined( 'ABSPATH' ) ) {
	die;
} // Cannot access pages directly.
/**
 * Field: Range
 */
if ( ! class_exists( 'WLDCFWC_Exopite_Simple_Options_Framework_Field_range' ) ) {

	class WLDCFWC_Exopite_Simple_Options_Framework_Field_Range extends WLDCFWC_Exopite_Simple_Options_Framework_Fields {


		public function __construct( $field, $value = '', $unique = '', $config = array() ) {
			parent::__construct( $field, $value, $unique, $config );
		}

		public function wldcfwc_output() {

			/**
			 * Update input if range changed
			 *
			 * @link https://stackoverflow.com/questions/10004723/html5-input-type-range-show-range-value/45210546#45210546
			 */
			$attr = array();
			if ( ! empty( $this->field['min'] ) ) {
				$attr[] = 'min="' . esc_attr( $this->field['min'] ) . '" ';
			}
			if ( ! empty( $this->field['max'] ) ) {
				$attr[] = 'max="' . esc_attr( $this->field['max'] ) . '" ';
			}
			if ( ! empty( $this->field['step'] ) ) {
				$attr[] = 'step="' . esc_attr( $this->field['step'] ) . '" ';
			}
			$attrs             = ( ! empty( $attr ) ) ? ' ' . trim( implode( ' ', $attr ) ) : '';
			$unit              = ( isset( $this->field['unit'] ) ) ? '<em>' . $this->field['unit'] . '</em>' : '';
			$classes           = ( isset( $this->field['class'] ) ) ? implode( ' ', explode( ' ', $this->field['class'] ) ) : '';
			$allowed_html_tags = wldcfwc_setAllowedTags( 'post,svg' );

			echo wp_kses( $this->wldcfwc_element_before(), $allowed_html_tags );

			echo '<input type="range" name="' . esc_attr( $this->wldcfwc_element_name() ) . '" oninput="updateRangeInput(this)" class="range ' . wp_kses( $classes, array() ) . '" ' . wp_kses( $attrs, array() ) . ' value="' . esc_attr( $this->wldcfwc_element_value() ) . '" ' . wp_kses( $this->wldcfwc_element_attributes(), array() ) . '>' . wp_kses( $unit, $allowed_html_tags );
			echo '<input type="number" value="' . esc_attr( $this->wldcfwc_element_value() ) . '" oninput="updateInputRange(this)" class="exopite-range-input" ' . wp_kses( $attrs, array() ) . '>';

			echo wp_kses( $this->wldcfwc_element_after(), $allowed_html_tags );
		}
	}

}
